Package weka.gui.experiment

# Class AbstractSetupPanel

java.lang.Object
java.awt.Component
java.awt.Container
javax.swing.JComponent
javax.swing.JPanel
weka.gui.experiment.AbstractSetupPanel

All Implemented Interfaces:
  `ImageObserver`, `MenuContainer`, `Serializable`, `Comparable<AbstractSetupPanel>`, `Accessible`

Direct Known Subclasses:
  `SetupPanel`, `SimpleSetupPanel`

public abstract class AbstractSetupPanel extends JPanel implements Comparable<AbstractSetupPanel>
Ancestor for setup panels for experiments.

Version:
  $Revision$
Author:
  FracPete (fracpete at waikato dot ac dot nz)
See Also:
  - Serialized Form

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class javax.swing.JComponent

  `JComponent.AccessibleJComponent`

  ## Nested classes/interfaces inherited from class java.awt.Component

  `Component.BaselineResizeBehavior`

- ## Field Summary

  ### Fields inherited from class javax.swing.JComponent

  `TOOL_TIP_TEXT_KEY, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

  ### Fields inherited from class java.awt.Component

  `BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

  ### Fields inherited from interface java.awt.image.ImageObserver

  `ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `AbstractSetupPanel()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `abstract void`
  `addPropertyChangeListener(PropertyChangeListener l)`
  Adds a PropertyChangeListener who will be notified of value changes.
  `void`
  `cleanUpAfterSwitch()`
  Hook method for cleaning up the interface after a switch.
  `int`
  `compareTo(AbstractSetupPanel o)`
  Uses the name for comparison.
  `abstract Experiment`
  `getExperiment()`
  Gets the currently configured experiment.
  `abstract String`
  `getName()`
  Returns the name of the panel.
  `static AbstractSetupPanel[]`
  `getPanels()`
  Returns a list of all available setup panels.
  `abstract void`
  `removePropertyChangeListener(PropertyChangeListener l)`
  Removes a PropertyChangeListener.
  `abstract boolean`
  `setExperiment(Experiment exp)`
  Sets the experiment to configure.
  `abstract void`
  `setModePanel(SetupModePanel modePanel)`
  Sets the panel used to switch between simple and advanced modes.
  `abstract void`
  `terminate()`
  Terminates this panel.
  `String`
  `toString()`
  Just returns the name of the panel.

  ### Methods inherited from class javax.swing.JPanel

  `getAccessibleContext, getUI, getUIClassID, setUI, updateUI`

  ### Methods inherited from class javax.swing.JComponent

  `addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, hide, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintImmediately, paintImmediately, print, printAll, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

  ### Methods inherited from class java.awt.Container

  `add, add, add, add, add, addContainerListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusDownCycle, validate`

  ### Methods inherited from class java.awt.Component

  `action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, contains, createImage, createImage, createVolatileImage, createVolatileImage, dispatchEvent, enable, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getParent, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, repaint, repaint, repaint, requestFocus, requestFocusInWindow, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setMixingCutoutShape, setName, setSize, setSize, show, show, size, transferFocus, transferFocusBackward, transferFocusUpCycle`

  ### Methods inherited from class java.lang.Object

  `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### AbstractSetupPanel

    public AbstractSetupPanel()

- ## Method Details

  - ### getName

    public abstract String getName()
    Returns the name of the panel.
    Overrides:
      `getName` in class `Component`
    Returns:
      the name

  - ### setModePanel

    public abstract void setModePanel(SetupModePanel modePanel)
    Sets the panel used to switch between simple and advanced modes.
    Parameters:
      `modePanel` - the panel

  - ### setExperiment

    public abstract boolean setExperiment(Experiment exp)
    Sets the experiment to configure.
    Parameters:
      `exp` - a value of type 'Experiment'
    Returns:
      true if experiment could be configured, false otherwise

  - ### getExperiment

    public abstract Experiment getExperiment()
    Gets the currently configured experiment.
    Returns:
      the currently configured experiment.

  - ### cleanUpAfterSwitch

    public void cleanUpAfterSwitch()
    Hook method for cleaning up the interface after a switch.
    Default implementation does nothing.

  - ### addPropertyChangeListener

    public abstract void addPropertyChangeListener(PropertyChangeListener l)
    Adds a PropertyChangeListener who will be notified of value changes.
    Overrides:
      `addPropertyChangeListener` in class `Container`
    Parameters:
      `l` - a value of type 'PropertyChangeListener'

  - ### removePropertyChangeListener

    public abstract void removePropertyChangeListener(PropertyChangeListener l)
    Removes a PropertyChangeListener.
    Overrides:
      `removePropertyChangeListener` in class `Component`
    Parameters:
      `l` - a value of type 'PropertyChangeListener'

  - ### compareTo

    public int compareTo(AbstractSetupPanel o)
    Uses the name for comparison.
    Specified by:
      `compareTo` in interface `Comparable<AbstractSetupPanel>`
    Parameters:
      `o` - the other panel
    Returns:
      <0 , 0, >0 if name is less than, equal or greater than this one
    See Also:
      - `getName()`

  - ### toString

    public String toString()
    Just returns the name of the panel.
    Overrides:
      `toString` in class `Component`
    Returns:
      the name

  - ### getPanels

    public static AbstractSetupPanel[] getPanels()
    Returns a list of all available setup panels.
    Returns:
      the available panels

  - ### terminate

    public abstract void terminate()
    Terminates this panel. To be implemented by actual concrete classes.